# 27jan23abu
# (c) Software Lab. Alexander Burger

(allowed ("wiki/" "db/wiki/blob/")
   *PW "!wiki" "!work" "!stop" "@lib.css" #{"!latex" "!pdf"}# "!psh"
   *PRG *Search "!showSource" "!getBlob" )

(scl 2)
(load
   "@lib/http.l" "@lib/xhtml.l" "@lib/form.l" #{"@lib/tex.l"}# "@lib/adm.l" )

(setq
   *Pool "db/wiki/"
   *Blob "db/wiki/blob/"
   *Jnl (and (info "fifo/wiki") "fifo/wiki")
   *Salt (16 . "$6$@1$")
   *Css "@lib.css"
   *WikiCss
   (quote
      #"https://fonts.googleapis.com/css?family=Share+Tech+Mono"
      #"https://fonts.googleapis.com/css?family=Exo:800,500"
      #"https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,600,600italic"
      "wiki/wiki.css" )
   *WikiPort 5000 )

(load "wiki/er.l" "wiki/lib.l" "wiki/gui.l")

(permission
   Wiki        "Edit Wiki Documents"
   System      "Edit System Data"
   Upload      "File upload"
   RoleAdmin   "Role Administration"
   UserAdmin   "User Administration"
   Password    "Password"
   Delete      "Delete" )

(mime "d" NIL 120)

# Entry point
(de main ()
   (call 'mkdir "-p" *Pool *Blob)
   (pool *Pool *Dbs *Jnl)
   (load "wiki/init.l")
   (unless (db 'nm '+Doc "home")
      (msg "No home document") )
   (if (db 'nm '+Doc "menu")
      (setq *WikiMenu (id @ T))
      (msg "No menu document") ) )

(de go ()
   (rollback)
   (retire 20)
   (gc 4)
   (server (or (format (sys "PORT")) *WikiPort) "!wiki") )

# vi:et:ts=3:sw=3
